<?php

namespace App\Entities;

use CodeIgniter\Entity\Entity;

abstract class CommonEntity extends Entity
{
    protected $datamap = [];
    protected $dates   = ['created_at', 'updated_at', 'deleted_at'];
    //사용법   : $client->created_at->format('Y-m-d') 
    //비교방법 : if ($client->created_at < new \DateTime('2024-01-01')) {
    public function __construct(array|null $data = null)
    {
        parent::__construct($data);
    }
    final public function getPK(): int|string
    {
        $field = constant("static::PK");
        return $this->attributes[$field] ?? "";
    }
    final public function getTitle(): string
    {
        $field = constant("static::TITLE");
        return $this->attributes[$field] ?? "";
    }
    final public function getTitleByFormat(string $format, array $fields): string
    {
        $parameters = array_map(fn($field) => $this->attributes[$field], $fields);
        return sprintf($format, ...$parameters);
    }
    public function getStatus(): string
    {
        return $this->attributes['status'] ?? "";
    }
    final public function getUpdatedAt(): string
    {
        return $this->attributes['updated_at'] ?? "";
    }
    final public function getCreatedAt(): string
    {
        return $this->attributes['created_at'] ?? "";
    }
    final public function getDeletedAt(): string
    {
        return $this->attributes['deleted_at'] ?? "";
    }
}
